///+------------------------------------------------------------------+
//|                                                    i_forum_6.mq4 |
//|                                     Copyright  2010, FXcasino |
//|                                             http://fxcasino.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, FXcasino"
#property link      "http://fxcasino.ru"

//+-------------------------------------------------------------------------------------------------------------------+
//|                                       ( )                                        |
extern double Lots             = 0.1;      // 
extern int    SL               = 50;       //Stop Loss    ( )
extern int    TP               = 100;       //Take Profit    ( )
extern int    Magic_Number     = 006;      // .     "" 
extern string Order_Comment    = "fxcasino.ru"; //,    
extern int    Slippage         = 100;      //  
extern int    Hour_To_Open     = -1; //  (-1 -  ),  
extern int    Minute_To_Open   = -1; //  (-1 -  ),  

extern int    Distance_To_Open = 100; //     
//+----------------------------------------------------------------------+
//+                           -                              +
extern bool   UseTrailing   = true;          /// T-SL
extern int    TrailingStop  = 50;           //   
extern int    TrailingStep  = 1;            //  
//+                           -                              +
//+----------------------------------------------------------------------+
//|                                       ( )                                        |
//+-------------------------------------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------------------------------------+
//|                                 ,                                    |
void init() {
  sound();
  return;
}
//|                                 ,                                    |
//+-------------------------------------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------------------------------------+
//|                                ,                                   |
void deinit() {

  return;
}
//|                                ,                                   |
//+-------------------------------------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------------------------------------+
//|                                                                 |
void sound() {
  int c=num_of_orders(Magic_Number);
  if(GlobalVariableCheck("num_of_oppened_"+Symbol()+"_"+Magic_Number)) { //   (   ) 
    if(GlobalVariableGet("num_of_oppened_"+Symbol()+"_"+Magic_Number)!=c) { //    -  
      GlobalVariableSet("num_of_oppened_"+Symbol()+"_"+Magic_Number,c);      
      PlaySound("alert.wav");
    }  
    return;
  } 
  
  GlobalVariableSet("num_of_oppened_"+Symbol()+"_"+Magic_Number,c);
  return; 
}
//|                                                                 |
//+-------------------------------------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------------------------------------+
//|                                                                                |
int num_of_orders(int magic) { 
  /*  ,             */
  int i=0,
      result=0;
  for(i=OrdersTotal()-1; i>=0; i--) {
    if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
    if((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol())) {
      //  ,    result
      result++;
    } //end if((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()))
  } //end for(i=OrdersTotal()-1; i>=0; i--)

  return(result); // false
} //end bool find_orders(int magic, int type)
//|                                                                                |
//+-------------------------------------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------------------------------------+
//|                                                                                    |
bool find_orders(int magic, int type) { 
  /*  ,             */
  int i=0;
  for(i=OrdersTotal()-1; i>=0; i--) {
    if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
    if((OrderType()==type) && (OrderMagicNumber()==magic) && (OrderSymbol()==Symbol())) {
      //  ,   true    
      return(true);
      break;
    } //end if((OrderType()==type) && (OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()))
  } //end for(i=OrdersTotal()-1; i>=0; i--)

  return(false); // false
} //end bool find_orders(int magic, int type)
//|                                                                                    |
//+-------------------------------------------------------------------------------------------------------------------+
  
//+-------------------------------------------------------------------------------------------------------------------+
//|                                                                                                   |
void T_SL() {
  int i=0;
  for(i=0; i<OrdersTotal(); i++) {
    if(!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) continue;
    if(OrderSymbol() != Symbol()) continue;       

    if(OrderType()==OP_BUY) {
      if(NormalizeDouble(Bid-OrderOpenPrice(),Digits)>NormalizeDouble(TrailingStop*Point,Digits)) {
        if(NormalizeDouble(OrderStopLoss(),Digits)<NormalizeDouble(Bid-(TrailingStop+TrailingStep-1)*Point,Digits))
          OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(Bid-TrailingStop*Point,Digits), OrderTakeProfit(), 0, CLR_NONE);
      } //end if(NormalizeDouble(Bid-OrderOpenPrice(),Digits)>NormalizeDouble(TrailingStop*Point,Digits))
    } //end if(OrderType()==OP_BUY)

    if(OrderType()==OP_SELL) {
      if(NormalizeDouble(OrderOpenPrice()-Ask,Digits)>NormalizeDouble(TrailingStop*Point,Digits)) {
        if(NormalizeDouble(OrderStopLoss(),Digits)>NormalizeDouble(Ask+(TrailingStop+TrailingStep-1)*Point,Digits))
          OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(Ask+TrailingStop*Point,Digits), OrderTakeProfit(), 0, CLR_NONE);
      } //end if(NormalizeDouble(OrderOpenPrice()-Ask,Digits)>NormalizeDouble(TrailingStop*Point,Digits))
    } //end if(OrderType()==OP_SELL)
  } //end for(i=0; i<OrdersTotal(); i++)
} //end void T_SL()
//|                                                                                                   |
//+-------------------------------------------------------------------------------------------------------------------+
//+-------------------------------------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------------------------------------+
//|                                     Stop Loss                                     |
double sl(int sl_value, double price, int mode) { //  Stop Loss  
  //mode=1 -> 
  //mode=2 -> 
  if(sl_value<=0) return(0);
  if(mode==4)     return(NormalizeDouble(price-sl_value*Point,Digits)); // 
  if(mode==5)     return(NormalizeDouble(price+sl_value*Point,Digits)); // 
} //end double sl(int sl_value, int mode)
//|                                     Stop Loss                                     |
//+-------------------------------------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------------------------------------+
//|                                    Take Profit                                    |
double tp(int tp_value, double price, int mode) { //  Take Profit  
  //mode=1 -> 
  //mode=2 -> 
  if(tp_value<=0) return(0);
  if(mode==4)     return(NormalizeDouble(price+tp_value*Point,Digits)); // 
  if(mode==5)     return(NormalizeDouble(price-tp_value*Point,Digits)); // 
} //end double tp(int tp_value, int mode)
//|                                    Take Profit                                    |
//+-------------------------------------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------------------------------------+
//|                                                                                             |
void open_positions(int signal, double op_price, double lots) { // 
  //signal=1 ->    
  //signal=2 ->    
  int    i     = 0;
  int    count = 5; //     ,    e  
  double price = 0.0; // 
  
  if(signal==4) price=NormalizeDouble(op_price+Distance_To_Open*Point,Digits); //   
  if(signal==5) price=NormalizeDouble(op_price-Distance_To_Open*Point,Digits); //   
  while(i<=count) {
    int ticket = OrderSend(Symbol(),
                           signal,
                           lots,
                           price,
                           Slippage,
                           sl(SL,price,signal),
                           tp(TP,price,signal),
                           Order_Comment,
                           Magic_Number,
                           0,
                           CLR_NONE);
    if(ticket!=-1)
      break;
    i++;  
  } //end while(i<=count)
} //end void open_positions(int signal)
//|                                                                                             |
//+-------------------------------------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------------------------------------+
//|                                                                                                     |
void start() {
  double price = 0.0;
  if((Hour()==Hour_To_Open) && (Minute()==Minute_To_Open)) { //    
    price = NormalizeDouble(Bid,Digits);
    if((!find_orders(Magic_Number, 0)) && (!find_orders(Magic_Number, 4))) //    OP_BUY  OP_BUYSTOP
      open_positions(4, price, Lots); //  BUYSTOP
    if((!find_orders(Magic_Number, 1)) && (!find_orders(Magic_Number, 5))) //    OP_SELL  OP_SELLSTOP
      open_positions(5, price, Lots); //  SELLSTOP
  } //end if((Hour()==Hour_To_Open) && (Minute()==Minute_To_Open))
  
  T_SL();
  sound();
  return;
} //end void start()
//|                                                        